                  (* +------------------------------------+
                     |  Dmonstration des arcs de Bzier  |
                     +------------------------------------+ *)


directory "..";;  (* adapter en fonction des circonstances *)

#open "graphx";;
load_object "graphx";;

let lgende() =
  set_color black;
  let y = ref (size_y()) in
  do_list (fun s -> y := !y - 30; moveto {x=10; y = !y}; draw_string s)
  ["Dplacer les points de contrle  l'aide de la souris";
   "Appuyer sur p (write_postscript)";
   "            f (write_fig)";
   "            k (write_pstricks)";
   "            g (write_tga)";
   "            n (write_ppm)";
   "            r (write_ppmraw)";
   "            t (terminer)"]
;;

(* trace une courbe de Bzier et les points de contrle *)
let trace(v) =
  set_line_width 1;
  set_color black;            draw_poly v;
  set_color blue;             draw_bezier 1 v;
  set_color red;              draw_bezier 2 v;
  set_line_width 2;
  set_color (rgb 100 200 50); draw_bezier 4 v;
  set_color black; for i=0 to vect_length(v)-1 do fill_circle v.(i) 5 done

;;

(* Renvoie l'index du point du tableau [points] le plus proche de [p] *)
let nearest p points =
  let distance {x=x1; y=y1} {x=x2; y=y2} = abs(x1-x2) + abs(y1-y2) in
  let i = ref 0
  and d = ref (distance p points.(0)) in
  for j = 1 to (vect_length points) - 1 do
    let d' = distance p points.(j) in
    if d' < !d then begin i := j; d := d' end
  done;
  !i
;;

(* dmonstration *)
let demo() =
  let v = [| {x=100; y=50};
             {x=100; y=150}; {x=200; y=150}; {x=250; y=100};
             {x=300; y=50};  {x=400; y=50};  {x=400; y=150} |]
  and encore = ref true
  and pt = ref(-1)
  in

  open_graph "";
  set_record true;
  lgende();
  trace(v);
  while !encore do
     match wait_next_event [Button_down; Button_up; Mouse_motion; Key_pressed] with

     | {keypressed=true; key=`f`} -> write_fig        "bezier.fig"
     | {keypressed=true; key=`p`} -> write_postscript "bezier.ps"
     | {keypressed=true; key=`k`} -> write_pstricks   "bezier.tex"
     | {keypressed=true; key=`g`} -> write_tga        "bezier.tga"
     | {keypressed=true; key=`n`} -> write_ppm        "bezier.ppm"
     | {keypressed=true; key=`r`} -> write_ppmraw     "bezier.ppm"
     | {keypressed=true; key=`t`} -> encore := false

     | {button=false} -> pt := -1
     | {button=true; mouse=m} ->
         if !pt < 0 then pt := nearest m v;
         if m <> v.(!pt) then begin
           v.(!pt) <- m;
           clear_graph();
           lgende();
           trace(v)
         end
  done;
  close_graph()

;;

if sys__interactive then begin
  print_string "lancer la fonction \"demo()\"";
  print_newline()
end
else demo()
;; 

